package com.sf.web.dms.statistics.service.impl;

package ..deTemp.1731161183858;

import com.sf.web.dms.common.dao.RTHDBDao;
import com.sf.web.dms.statistics.proxy.Zone1AuthHandler;
import com.sf.web.dms.statistics.service.CustomizeService;
import com.sf.web.dms.statistics.service.RtuOnlineService;
import com.sf.web.dms.util.SysCommUtil;
import com.smartframework.core.dao.JdbcDao;
import com.smartframework.core.dao.page.PagingBean;
import com.smartframework.core.smart.SmartHelper;
import com.smartframework.web.core.Constants;
import com.smartframework.web.core.database.ColumnRefInfo;
import com.smartframework.web.core.queryfilter.QueryFilter;
import com.smartframework.web.core.util.TranslateUtil;
import com.smartframework.web.system.utility.util.CommonTranslateUtil;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.log4j.Logger;

public class RtuOnlineServiceImpl implements RtuOnlineService {
  private Logger logger = Logger.getLogger(com.sf.web.dms.statistics.service.impl.RtuOnlineServiceImpl.class);
  
  private JdbcDao jdbcDao;
  
  private RTHDBDao rthDbDao = (RTHDBDao)SmartHelper.getBean("rthDbDao");
  
  public JdbcDao getJdbcDao() {
    return this.jdbcDao;
  }
  
  public void setJdbcDao(JdbcDao jdbcDao) {
    this.jdbcDao = jdbcDao;
  }
  
  public List<Long> GetStationListByOrg(Long iOrgId) {
    return new ArrayList<>();
  }
  
  public List<Integer> GetRtuListByCompositeswitch(Long iComId) {
    String printFullSql = "select id from fes_rtu where container_tablename = 'con_compositeswitch' and container_id = " + iComId;
    this.logger.info(printFullSql);
    List<Map<String, Object>> records = this.jdbcDao.queryForList(printFullSql);
    List<Integer> rtuList = new ArrayList<>();
    for (int i = 0; i < records.size(); i++)
      rtuList.add((Integer)((Map)records.get(i)).get("id")); 
    if (rtuList.isEmpty())
      rtuList.add(Integer.valueOf(-12345)); 
    return rtuList;
  }
  
  public List<Map<String, Object>> queryRecordsZ1(QueryFilter queryFilter0, QueryFilter queryFilter1, QueryFilter queryFilter2, Date endTime, Integer level, Integer orgId, Zone1AuthHandler z1h) {
    PagingBean pb = queryRecords(queryFilter0, queryFilter1, queryFilter2, endTime, level, orgId, z1h);
    List<Map<String, Object>> records = pb.getData();
    return records;
  }
  
  public List<Map<String, Object>> queryRecordsByStatusZ1(QueryFilter queryFilter0, QueryFilter queryFilter1, QueryFilter queryFilter2, Date endTime, Integer currentStatus, Integer level, Integer orgId, Zone1AuthHandler z1h) {
    PagingBean pb = queryRecordsByStatus(queryFilter0, queryFilter1, queryFilter2, endTime, currentStatus, level, orgId, z1h);
    List<Map<String, Object>> records = pb.getData();
    return records;
  }
  
  public PagingBean queryRecords(QueryFilter queryFilter0, QueryFilter queryFilter1, QueryFilter queryFilter2, Date endTime, Integer level, Integer orgId, Zone1AuthHandler z1h) {
    String WhereClause0 = queryFilter0.getNoWherePreFilledValWhereSql();
    String WhereClause1 = queryFilter1.getNoWherePreFilledValWhereSql();
    String WhereClause2 = queryFilter2.getNoWherePreFilledValWhereSql();
    StringBuilder sb = new StringBuilder();
    if (WhereClause0 != null && WhereClause0.trim().length() > 0)
      WhereClause0 = " and " + WhereClause0; 
    SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    String endTimeString = " timestamp '" + df.format(endTime) + "' ";
    Integer replaceOrgIdWithAreaResp = Constants.getInteger("statistics.assetRtu.replaceDivisionIdWithAreaResp", Integer.valueOf(0));
    Integer feederAreaDesc = Constants.getInteger("statistics.yk.feederAreaDesc", Integer.valueOf(0));
    Integer rtuBegin = CustomizeService.queryRtuBegin();
    if (WhereClause1 == null || WhereClause1.trim().length() == 0) {
      if (WhereClause2 != null && WhereClause2.trim().length() > 0) {
        WhereClause2 = " where " + WhereClause2;
      } else {
        WhereClause2 = "";
      } 
      if (replaceOrgIdWithAreaResp.intValue() == 1) {
        sb.append("select * from (select distinct a.did, a.description, a.area_resp, a.is_unused, a.is_encrypt, a.division_id, a.station_id, a.feeder_id, a.type, a.manu_fac, a.comm_type, a.remote_ip, b.online_rate, b.online_sum, total_hour, (round(total_hour-online_sum,2)) as offline_hour, b.lost_sum, a.is_transmit, ");
        sb.append("b.max_online as ut_lastonline, b.max_offline as ut_lastoffline, b.max_duration as last_offline_time from ");
        sb.append("((select distinct(e.id) as did, dev.area_resp, e.description,fes_group.type as is_encrypt, e.is_unused, get_division_id(e.container_id,e.container_tablename) as division_id, get_station_id(e.container_id,e.container_tablename) as station_id, get_feeder_id(e.container_id,e.container_tablename) as feeder_id, e.type, e.manu_fac, e.comm_type, e.is_transmit, e.sour1, fes_chan_extend.remote_ip  from fes_rtu e ");
      } else if (feederAreaDesc.intValue() == 1) {
        sb.append("select * from (select distinct a.did, a.organization, a.description, a.is_unused, a.is_encrypt, a.division_id, a.station_id, a.feeder_id, a.type, a.manu_fac, a.comm_type, a.remote_ip, b.online_rate, b.online_sum, total_hour, (round(total_hour-online_sum,2)) as offline_hour, b.lost_sum, a.is_transmit, ");
        sb.append("b.max_online as ut_lastonline, b.max_offline as ut_lastoffline, b.max_duration as last_offline_time from ");
        sb.append("((select distinct(e.id) as did, e.description,fes_group.type as is_encrypt, e.is_unused, get_division_id(e.container_id,e.container_tablename) as division_id, get_station_id(e.container_id,e.container_tablename) as station_id, get_feeder_id(e.container_id,e.container_tablename) as feeder_id, e.type, e.manu_fac, e.comm_type, e.is_transmit, e.sour1, e.organization, fes_chan_extend.remote_ip  from fes_rtu e ");
      } else {
        sb.append("select * from (select distinct a.did, a.description, a.is_unused, a.is_encrypt, a.division_id, a.station_id, a.feeder_id, a.type, a.manu_fac, a.comm_type, a.remote_ip, b.online_rate, b.online_sum, total_hour, (round(total_hour-online_sum,2)) as offline_hour, b.lost_sum, a.is_transmit, ");
        sb.append("b.max_online as ut_lastonline, b.max_offline as ut_lastoffline, b.max_duration as last_offline_time from ");
        sb.append("((select distinct(e.id) as did, e.description,fes_group.type as is_encrypt, e.is_unused, get_division_id(e.container_id,e.container_tablename) as division_id, get_station_id(e.container_id,e.container_tablename) as station_id, get_feeder_id(e.container_id,e.container_tablename) as feeder_id, e.type, e.manu_fac, e.comm_type, e.is_transmit, e.sour1, fes_chan_extend.remote_ip  from fes_rtu e ");
      } 
      sb.append("left join fes_chan_extend on sour1 = fes_chan_extend.id ");
      sb.append(" left join fes_chan on fes_chan.id = e.sour1");
      if (replaceOrgIdWithAreaResp.intValue() == 1)
        sb.append(" left join obj_dev dev on e.dev_id = dev.id "); 
      sb.append(" left join fes_group on fes_group.id = fes_chan.group_id ");
      if (rtuBegin.intValue() > 0) {
        sb.append("where e.is_unused = 0 and e.id >= " + rtuBegin.toString() + " ) a left join ");
      } else {
        sb.append("where e.is_unused = 0 and e.id%10!=8 ) a left join ");
      } 
      sb.append("(select distinct id as id, round(CAST(sum(online_sec) AS double)/3600,2) as online_sum, CAST(sum(24) AS double) as total_hour, round(CAST(sum(online_sec) AS double)/sum(864),2) as online_rate,sum(lost_cnt) as lost_sum, ");
      sb.append("max(ut_lastoffline) as max_offline, max(ut_lastonline) as max_online, ");
      sb.append("(CASE ");
      if (QueryFilter.isKingbaseDB() || QueryFilter.isPgSQLDB()) {
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is not null and max(ut_lastoffline)>max(ut_lastonline) THEN extract(day from ((" + endTimeString + ")-max(ut_lastoffline)))*24 + extract(hour from ((" + endTimeString + ")-max(ut_lastoffline))) ");
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is null THEN extract(day from ((" + endTimeString + ")-max(ut_lastoffline)))*24 + extract(hour from ((" + endTimeString + ")-max(ut_lastoffline))) ");
      } else {
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is not null and max(ut_lastoffline)>max(ut_lastonline) THEN round(((" + endTimeString + ")-max(ut_lastoffline))*24,2) ");
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is null THEN round(((" + endTimeString + ")-max(ut_lastoffline))*24,2) ");
      } 
      sb.append("WHEN max(ut_lastoffline) is null and max(ut_lastonline) is null THEN null ");
      sb.append("ELSE 0 ");
      sb.append("END) as max_duration ");
      sb.append("from statistics_rtu_online e group by id) b ");
      sb.append("on a.did = b.id) ");
    } else {
      if (WhereClause2 != null && WhereClause2.trim().length() > 0) {
        WhereClause2 = " where " + WhereClause2;
      } else {
        WhereClause2 = "";
      } 
      if (replaceOrgIdWithAreaResp.intValue() == 1) {
        sb.append("select * from (select distinct a.did, a.description, a.area_resp, a.is_unused, a.is_encrypt, a.division_id, a.station_id, a.feeder_id, a.type, a.manu_fac, a.comm_type, a.remote_ip, b.online_rate, b.online_sum, total_hour, (round(total_hour-online_sum,2)) as offline_hour, b.lost_sum, a.is_transmit, ");
        sb.append("b.max_online as ut_lastonline, b.max_offline as ut_lastoffline, b.max_duration as last_offline_time from ");
        sb.append("((select distinct(e.id) as did, dev.area_resp, e.description,fes_group.type as is_encrypt, e.is_unused, get_division_id(e.container_id,e.container_tablename) as division_id, get_station_id(e.container_id,e.container_tablename) as station_id, get_feeder_id(e.container_id,e.container_tablename) as feeder_id, e.type, e.manu_fac, e.comm_type, e.is_transmit, e.sour1, fes_chan_extend.remote_ip  from fes_rtu e ");
      } else if (feederAreaDesc.intValue() == 1) {
        sb.append("select * from (select distinct a.did, a.organization, a.description, a.is_unused, a.is_encrypt, a.division_id, a.station_id, a.feeder_id, a.type, a.manu_fac, a.comm_type, a.remote_ip, b.online_rate, b.online_sum, total_hour, (round(total_hour-online_sum,2)) as offline_hour, b.lost_sum, a.is_transmit, ");
        sb.append("b.max_online as ut_lastonline, b.max_offline as ut_lastoffline, b.max_duration as last_offline_time from ");
        sb.append("((select distinct(e.id) as did, e.description,fes_group.type as is_encrypt, e.is_unused, get_division_id(e.container_id,e.container_tablename) as division_id, get_station_id(e.container_id,e.container_tablename) as station_id, get_feeder_id(e.container_id,e.container_tablename) as feeder_id, e.type, e.manu_fac, e.comm_type, e.is_transmit, e.sour1, e.organization, fes_chan_extend.remote_ip  from fes_rtu e ");
      } else {
        sb.append("select * from (select distinct a.did, a.description, a.is_unused, a.is_encrypt, a.division_id, a.station_id, a.feeder_id, a.type, a.manu_fac, a.comm_type, a.remote_ip, b.online_rate, b.online_sum, total_hour, (round(total_hour-online_sum,2)) as offline_hour, b.lost_sum, a.is_transmit, ");
        sb.append("b.max_online as ut_lastonline, b.max_offline as ut_lastoffline, b.max_duration as last_offline_time from ");
        sb.append("((select distinct(e.id) as did, e.description,fes_group.type as is_encrypt, e.is_unused, get_division_id(e.container_id,e.container_tablename) as division_id, get_station_id(e.container_id,e.container_tablename) as station_id, get_feeder_id(e.container_id,e.container_tablename) as feeder_id, e.type, e.manu_fac, e.comm_type, e.is_transmit, e.sour1, fes_chan_extend.remote_ip  from fes_rtu e ");
      } 
      sb.append("left join fes_chan_extend on sour1 = fes_chan_extend.id ");
      sb.append(" left join fes_chan on fes_chan.id = e.sour1");
      if (replaceOrgIdWithAreaResp.intValue() == 1)
        sb.append(" left join obj_dev dev on e.dev_id = dev.id "); 
      sb.append(" left join fes_group on fes_group.id = fes_chan.group_id ");
      if (rtuBegin.intValue() > 0) {
        sb.append("where e.is_unused = 0 and e.id >= " + rtuBegin.toString() + " ");
      } else {
        sb.append("where e.is_unused = 0 and e.id%10!=8 ");
      } 
      sb.append(WhereClause0);
      sb.append(") a left join ");
      sb.append("(select distinct id as id, round(CAST(sum(online_sec) AS double)/3600,2) as online_sum, CAST(sum(24) AS double) as total_hour, round(CAST(sum(online_sec) AS double)/sum(864),2) as online_rate,sum(lost_cnt) as lost_sum, ");
      sb.append("max(ut_lastoffline) as max_offline, max(ut_lastonline) as max_online, ");
      sb.append("(CASE ");
      if (QueryFilter.isKingbaseDB() || QueryFilter.isPgSQLDB()) {
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is not null and max(ut_lastoffline)>max(ut_lastonline) THEN extract(day from ((" + endTimeString + ")-max(ut_lastoffline)))*24 + extract(hour from ((" + endTimeString + ")-max(ut_lastoffline))) ");
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is null THEN extract(day from ((" + endTimeString + ")-max(ut_lastoffline)))*24 + extract(hour from ((" + endTimeString + ")-max(ut_lastoffline))) ");
      } else {
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is not null and max(ut_lastoffline)>max(ut_lastonline) THEN round(((" + endTimeString + ")-max(ut_lastoffline))*24,2) ");
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is null THEN round(((" + endTimeString + ")-max(ut_lastoffline))*24,2) ");
      } 
      sb.append("WHEN max(ut_lastoffline) is null and max(ut_lastonline) is null THEN null ");
      sb.append("ELSE 0 ");
      sb.append("END) as max_duration ");
      sb.append("from statistics_rtu_online e where ");
      sb.append(WhereClause1);
      sb.append(" group by id) b ");
      sb.append("on a.did = b.id) ");
    } 
    if (z1h == null) {
      sb.append("left join auth_orgrtu auth on auth.rtu_id=a.did ");
      String userAuthOrgLinkSQL = SysCommUtil.userAuthOrgLinkSQL(level, orgId);
      sb.append(" inner join (");
      sb.append(userAuthOrgLinkSQL).append(") org on auth.org_id=org.user_auth_org_id)");
    } else {
      this.logger.info("一区请求的regionId为: " + z1h.regionId);
      if (Constants.integerConfigIsEnabled("dms.load.statistics.data")) {
        this.logger.info("一区请求，指标结果与四区一致");
        sb.append(" left join auth_orgrtu auth on auth.rtu_id=a.did ");
        sb.append(" inner join (");
        sb.append(" select id user_auth_org_id from sys_organization where id").append(level)
          .append("=").append(orgId)
          .append(") org on auth.org_id=org.user_auth_org_id )");
      } else {
        sb.append(z1h.areaRespLinkSQL());
        sb.append(")");
      } 
    } 
    sb.append(WhereClause2);
    sb.append(" order by division_id, station_id, feeder_id");
    String printFullSql = sb.toString();
    this.logger.info(printFullSql);
    PagingBean pb = this.jdbcDao.queryForPaging(printFullSql, queryFilter1.getPageSize().intValue(), queryFilter1.getPageIndex().intValue());
    List<Map<String, Object>> records = pb.getData();
    if (replaceOrgIdWithAreaResp.intValue() == 1) {
      this.logger.info("==========> baoding: replaceOrgIdWithAreaResp==1");
      for (int k = 0; k < records.size(); k++)
        ((Map)records.get(k)).put("divisionId", ((Map)records.get(k)).get("areaResp")); 
    } 
    String rtuIdListString = new String();
    String printFullSql2 = new String();
    for (int i = 0; i < records.size(); i++)
      rtuIdListString = rtuIdListString + ((Map)records.get(i)).get("did") + ","; 
    if (rtuIdListString.contains(",")) {
      rtuIdListString = rtuIdListString.substring(0, rtuIdListString.length() - 1);
      printFullSql2 = "select id, status from real_fes_fes_rtu where id in (" + rtuIdListString + ")";
    } else {
      printFullSql2 = "select id, status from real_fes_fes_rtu";
    } 
    List<Map<String, Object>> rtuStat = new ArrayList<>();
    this.logger.info(printFullSql2);
    rtuStat = this.rthDbDao.queryForList(printFullSql2);
    for (int j = 0; j < records.size(); j++) {
      for (int k = 0; k < rtuStat.size(); k++) {
        if (((Map)records.get(j)).get("did").equals(((Map)rtuStat.get(k)).get("id"))) {
          ((Map)records.get(j)).put("status", ((Map)rtuStat.get(k)).get("status"));
          rtuStat.remove(k);
          break;
        } 
      } 
    } 
    Map<String, String> dictNameFieldNameMap = new HashMap<>();
    dictNameFieldNameMap.put("type", "fes_rtu_type");
    dictNameFieldNameMap.put("commType", "terminal_communication_mode");
    dictNameFieldNameMap.put("manuFac", "terminal_manufacturer");
    dictNameFieldNameMap.put("status", "fes_node_status");
    dictNameFieldNameMap.put("isUnused", "pub_two_valued_logic");
    dictNameFieldNameMap.put("isTransmit", "life_cycle");
    dictNameFieldNameMap.put("isEncrypt", "rtu_is_encrypt");
    if (feederAreaDesc.intValue() == 1) {
      this.logger.info("==========> wuxi: feederAreaDesc==1");
      dictNameFieldNameMap.put("organization", "menu_rtu_organization");
    } 
    Map<String, ColumnRefInfo> filedRefInfoMap = new HashMap<>();
    if (replaceOrgIdWithAreaResp.intValue() == 1) {
      filedRefInfoMap.put("areaResp", new ColumnRefInfo("auth_region", "id", "description", ""));
      filedRefInfoMap.put("divisionId", new ColumnRefInfo("auth_region", "id", "description", ""));
    } else if (feederAreaDesc.intValue() != 1) {
      filedRefInfoMap.put("divisionId", new ColumnRefInfo("con_division", "id", "description", ""));
    } 
    filedRefInfoMap.put("stationId", new ColumnRefInfo("con_station", "id", "description", ""));
    filedRefInfoMap.put("feederId", new ColumnRefInfo("con_feeder", "id", "description", ""));
    try {
      CommonTranslateUtil.translateMultiDictColumn(records, dictNameFieldNameMap, TranslateUtil.DictItemColumRefType.VALUE_COLUMN);
      CommonTranslateUtil.translateMultiReferenceColumn(records, null, TranslateUtil.DictItemColumRefType.ID_COLUMN, filedRefInfoMap);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    if (feederAreaDesc.intValue() == 1) {
      this.logger.info("==========> wuxi: feederAreaDesc==1");
      for (int k = 0; k < records.size(); k++)
        ((Map)records.get(k)).put("divisionIdTranslateValue", ((Map)records.get(k)).get("organizationTranslateValue")); 
    } 
    return pb;
  }
  
  public PagingBean queryRecordsByStatus(QueryFilter queryFilter0, QueryFilter queryFilter1, QueryFilter queryFilter2, Date endTime, Integer currentStatus, Integer level, Integer orgId, Zone1AuthHandler z1h) {
    String printFullSql = "select id, status from real_fes_fes_rtu where status = " + currentStatus;
    this.logger.info(printFullSql);
    List<Map<String, Object>> rtuStat = this.rthDbDao.queryForList(printFullSql);
    String rtuIdListString = new String();
    String statWhere = new String();
    for (int i = 0; i < rtuStat.size(); i++)
      rtuIdListString = rtuIdListString + ((Map)rtuStat.get(i)).get("id") + ","; 
    if (rtuIdListString.contains(",")) {
      rtuIdListString = rtuIdListString.substring(0, rtuIdListString.length() - 1);
      statWhere = " did in (" + rtuIdListString + ") ";
    } else {
      statWhere = " did in (-12345) ";
    } 
    String WhereClause0 = queryFilter0.getNoWherePreFilledValWhereSql();
    String WhereClause1 = queryFilter1.getNoWherePreFilledValWhereSql();
    String WhereClause2 = queryFilter2.getNoWherePreFilledValWhereSql();
    StringBuilder sb = new StringBuilder();
    if (WhereClause0 != null && WhereClause0.trim().length() > 0)
      WhereClause0 = " and " + WhereClause0; 
    SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    String endTimeString = " timestamp '" + df.format(endTime) + "' ";
    Integer replaceOrgIdWithAreaResp = Constants.getInteger("statistics.assetRtu.replaceDivisionIdWithAreaResp", Integer.valueOf(0));
    Integer feederAreaDesc = Constants.getInteger("statistics.yk.feederAreaDesc", Integer.valueOf(0));
    Integer rtuBegin = CustomizeService.queryRtuBegin();
    if (WhereClause1 == null || WhereClause1.trim().length() == 0) {
      if (WhereClause2 != null && WhereClause2.trim().length() > 0) {
        WhereClause2 = " where " + WhereClause2;
      } else {
        WhereClause2 = "";
      } 
      if (replaceOrgIdWithAreaResp.intValue() == 1) {
        sb.append("select * from (select distinct a.did, a.description, a.area_resp, a.is_unused, a.is_encrypt, a.division_id, a.station_id, a.feeder_id, a.type, a.manu_fac, a.comm_type, a.remote_ip, b.online_rate, b.online_sum, total_hour, (round(total_hour-online_sum,2)) as offline_hour, b.lost_sum, a.is_transmit, ");
        sb.append("b.max_online as ut_lastonline, b.max_offline as ut_lastoffline, b.max_duration as last_offline_time from ");
        sb.append("((select distinct(e.id) as did, dev.area_resp, e.description,fes_group.type as is_encrypt, e.is_unused, get_division_id(e.container_id,e.container_tablename) as division_id, get_station_id(e.container_id,e.container_tablename) as station_id, get_feeder_id(e.container_id,e.container_tablename) as feeder_id, e.type, e.manu_fac, e.comm_type, e.is_transmit, e.sour1, fes_chan_extend.remote_ip  from fes_rtu e ");
      } else if (feederAreaDesc.intValue() == 1) {
        sb.append("select * from (select distinct a.did, a.organization, a.description, a.is_unused, a.is_encrypt, a.division_id, a.station_id, a.feeder_id, a.type, a.manu_fac, a.comm_type, a.remote_ip, b.online_rate, b.online_sum, total_hour, (round(total_hour-online_sum,2)) as offline_hour, b.lost_sum, a.is_transmit, ");
        sb.append("b.max_online as ut_lastonline, b.max_offline as ut_lastoffline, b.max_duration as last_offline_time from ");
        sb.append("((select distinct(e.id) as did, e.description,fes_group.type as is_encrypt, e.is_unused, get_division_id(e.container_id,e.container_tablename) as division_id, get_station_id(e.container_id,e.container_tablename) as station_id, get_feeder_id(e.container_id,e.container_tablename) as feeder_id, e.type, e.manu_fac, e.comm_type, e.is_transmit, e.sour1, e.organization, fes_chan_extend.remote_ip  from fes_rtu e ");
      } else {
        sb.append("select * from (select distinct a.did, a.description, a.is_unused, a.is_encrypt, a.division_id, a.station_id, a.feeder_id, a.type, a.manu_fac, a.comm_type, a.remote_ip, b.online_rate, b.online_sum, total_hour, (round(total_hour-online_sum,2)) as offline_hour, b.lost_sum, a.is_transmit, ");
        sb.append("b.max_online as ut_lastonline, b.max_offline as ut_lastoffline, b.max_duration as last_offline_time from ");
        sb.append("((select distinct(e.id) as did, e.description,fes_group.type as is_encrypt, e.is_unused, get_division_id(e.container_id,e.container_tablename) as division_id, get_station_id(e.container_id,e.container_tablename) as station_id, get_feeder_id(e.container_id,e.container_tablename) as feeder_id, e.type, e.manu_fac, e.comm_type, e.is_transmit, e.sour1, fes_chan_extend.remote_ip  from fes_rtu e ");
      } 
      sb.append("left join fes_chan_extend on sour1 = fes_chan_extend.id ");
      sb.append(" left join fes_chan on fes_chan.id = e.sour1");
      if (replaceOrgIdWithAreaResp.intValue() == 1)
        sb.append(" left join obj_dev dev on e.dev_id = dev.id "); 
      sb.append(" left join fes_group on fes_group.id = fes_chan.group_id ");
      if (rtuBegin.intValue() > 0) {
        sb.append("where e.is_unused = 0 and e.id >= " + rtuBegin.toString() + " ) a left join ");
      } else {
        sb.append("where e.is_unused = 0 and e.id%10!=8 ) a left join ");
      } 
      sb.append("(select distinct id as id, round(CAST(sum(online_sec) AS double)/3600,2) as online_sum, CAST(sum(24) AS double) as total_hour, round(CAST(sum(online_sec) AS double)/sum(864),2) as online_rate,sum(lost_cnt) as lost_sum, ");
      sb.append("max(ut_lastoffline) as max_offline, max(ut_lastonline) as max_online, ");
      sb.append("(CASE ");
      if (QueryFilter.isKingbaseDB() || QueryFilter.isPgSQLDB()) {
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is not null and max(ut_lastoffline)>max(ut_lastonline) THEN extract(day from ((" + endTimeString + ")-max(ut_lastoffline)))*24 + extract(hour from ((" + endTimeString + ")-max(ut_lastoffline))) ");
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is null THEN extract(day from ((" + endTimeString + ")-max(ut_lastoffline)))*24 + extract(hour from ((" + endTimeString + ")-max(ut_lastoffline))) ");
      } else {
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is not null and max(ut_lastoffline)>max(ut_lastonline) THEN round(((" + endTimeString + ")-max(ut_lastoffline))*24,2) ");
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is null THEN round(((" + endTimeString + ")-max(ut_lastoffline))*24,2) ");
      } 
      sb.append("WHEN max(ut_lastoffline) is null and max(ut_lastonline) is null THEN null ");
      sb.append("ELSE 0 ");
      sb.append("END) as max_duration ");
      sb.append("from statistics_rtu_online e group by id) b ");
      sb.append("on a.did = b.id) ");
    } else {
      if (WhereClause2 != null && WhereClause2.trim().length() > 0) {
        WhereClause2 = " where " + WhereClause2;
      } else {
        WhereClause2 = "";
      } 
      if (replaceOrgIdWithAreaResp.intValue() == 1) {
        sb.append("select * from (select distinct a.did, a.description, a.area_resp, a.is_unused, a.is_encrypt, a.division_id, a.station_id, a.feeder_id, a.type, a.manu_fac, a.comm_type, a.remote_ip, b.online_rate, b.online_sum, total_hour, (round(total_hour-online_sum,2)) as offline_hour, b.lost_sum, a.is_transmit, ");
        sb.append("b.max_online as ut_lastonline, b.max_offline as ut_lastoffline, b.max_duration as last_offline_time from ");
        sb.append("((select distinct(e.id) as did, dev.area_resp, e.description,fes_group.type as is_encrypt, e.is_unused, get_division_id(e.container_id,e.container_tablename) as division_id, get_station_id(e.container_id,e.container_tablename) as station_id, get_feeder_id(e.container_id,e.container_tablename) as feeder_id, e.type, e.manu_fac, e.comm_type, e.is_transmit, e.sour1, fes_chan_extend.remote_ip  from fes_rtu e ");
      } else if (feederAreaDesc.intValue() == 1) {
        sb.append("select * from (select distinct a.did, a.organization, a.description, a.is_unused, a.is_encrypt, a.division_id, a.station_id, a.feeder_id, a.type, a.manu_fac, a.comm_type, a.remote_ip, b.online_rate, b.online_sum, total_hour, (round(total_hour-online_sum,2)) as offline_hour, b.lost_sum, a.is_transmit, ");
        sb.append("b.max_online as ut_lastonline, b.max_offline as ut_lastoffline, b.max_duration as last_offline_time from ");
        sb.append("((select distinct(e.id) as did, e.description,fes_group.type as is_encrypt, e.is_unused, get_division_id(e.container_id,e.container_tablename) as division_id, get_station_id(e.container_id,e.container_tablename) as station_id, get_feeder_id(e.container_id,e.container_tablename) as feeder_id, e.type, e.manu_fac, e.comm_type, e.is_transmit, e.sour1, e.organization, fes_chan_extend.remote_ip  from fes_rtu e ");
      } else {
        sb.append("select * from (select distinct a.did, a.description, a.is_unused, a.is_encrypt, a.division_id, a.station_id, a.feeder_id, a.type, a.manu_fac, a.comm_type, a.remote_ip, b.online_rate, b.online_sum, total_hour, (round(total_hour-online_sum,2)) as offline_hour, b.lost_sum, a.is_transmit, ");
        sb.append("b.max_online as ut_lastonline, b.max_offline as ut_lastoffline, b.max_duration as last_offline_time from ");
        sb.append("((select distinct(e.id) as did, e.description,fes_group.type as is_encrypt, e.is_unused, get_division_id(e.container_id,e.container_tablename) as division_id, get_station_id(e.container_id,e.container_tablename) as station_id, get_feeder_id(e.container_id,e.container_tablename) as feeder_id, e.type, e.manu_fac, e.comm_type, e.is_transmit, e.sour1, fes_chan_extend.remote_ip  from fes_rtu e ");
      } 
      sb.append("left join fes_chan_extend on sour1 = fes_chan_extend.id ");
      sb.append(" left join fes_chan on fes_chan.id = e.sour1");
      if (replaceOrgIdWithAreaResp.intValue() == 1)
        sb.append(" left join obj_dev dev on e.dev_id = dev.id "); 
      sb.append(" left join fes_group on fes_group.id = fes_chan.group_id ");
      if (rtuBegin.intValue() > 0) {
        sb.append("where e.is_unused = 0 and e.id >= " + rtuBegin.toString() + " ");
      } else {
        sb.append("where e.is_unused = 0 and e.id%10!=8 ");
      } 
      sb.append(WhereClause0);
      sb.append(") a left join ");
      sb.append("(select distinct id as id, round(CAST(sum(online_sec) AS double)/3600,2) as online_sum, CAST(sum(24) AS double) as total_hour, round(CAST(sum(online_sec) AS double)/sum(864),2) as online_rate,sum(lost_cnt) as lost_sum, ");
      sb.append("max(ut_lastoffline) as max_offline, max(ut_lastonline) as max_online, ");
      sb.append("(CASE ");
      if (QueryFilter.isKingbaseDB() || QueryFilter.isPgSQLDB()) {
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is not null and max(ut_lastoffline)>max(ut_lastonline) THEN extract(day from ((" + endTimeString + ")-max(ut_lastoffline)))*24 + extract(hour from ((" + endTimeString + ")-max(ut_lastoffline))) ");
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is null THEN extract(day from ((" + endTimeString + ")-max(ut_lastoffline)))*24 + extract(hour from ((" + endTimeString + ")-max(ut_lastoffline))) ");
      } else {
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is not null and max(ut_lastoffline)>max(ut_lastonline) THEN round(((" + endTimeString + ")-max(ut_lastoffline))*24,2) ");
        sb.append("WHEN max(ut_lastoffline) is not null and max(ut_lastonline) is null THEN round(((" + endTimeString + ")-max(ut_lastoffline))*24,2) ");
      } 
      sb.append("WHEN max(ut_lastoffline) is null and max(ut_lastonline) is null THEN null ");
      sb.append("ELSE 0 ");
      sb.append("END) as max_duration ");
      sb.append("from statistics_rtu_online e where ");
      sb.append(WhereClause1);
      sb.append(" group by id) b ");
      sb.append("on a.did = b.id) ");
    } 
    if (z1h == null) {
      sb.append("left join auth_orgrtu auth on auth.rtu_id=a.did ");
      String userAuthOrgLinkSQL = SysCommUtil.userAuthOrgLinkSQL(level, orgId);
      sb.append(" inner join (");
      sb.append(userAuthOrgLinkSQL).append(") org on auth.org_id=org.user_auth_org_id)");
    } else {
      sb.append(z1h.areaRespLinkSQL());
    } 
    sb.append(WhereClause2);
    if (statWhere.length() > 0) {
      if (WhereClause2.length() == 0) {
        statWhere = " where " + statWhere;
      } else {
        statWhere = " and " + statWhere;
      } 
      sb.append(statWhere);
    } 
    sb.append(" order by division_id, station_id, feeder_id");
    printFullSql = sb.toString();
    this.logger.info(printFullSql);
    PagingBean pb = this.jdbcDao.queryForPaging(printFullSql, queryFilter1.getPageSize().intValue(), queryFilter1.getPageIndex().intValue());
    List<Map<String, Object>> records = pb.getData();
    if (replaceOrgIdWithAreaResp.intValue() == 1) {
      this.logger.info("==========> baoding: replaceOrgIdWithAreaResp==1");
      for (int k = 0; k < records.size(); k++)
        ((Map)records.get(k)).put("divisionId", ((Map)records.get(k)).get("areaResp")); 
    } 
    for (int j = 0; j < records.size(); j++)
      ((Map<String, Integer>)records.get(j)).put("status", currentStatus); 
    Map<String, String> dictNameFieldNameMap = new HashMap<>();
    dictNameFieldNameMap.put("type", "fes_rtu_type");
    dictNameFieldNameMap.put("commType", "terminal_communication_mode");
    dictNameFieldNameMap.put("manuFac", "terminal_manufacturer");
    dictNameFieldNameMap.put("status", "fes_node_status");
    dictNameFieldNameMap.put("isUnused", "pub_two_valued_logic");
    dictNameFieldNameMap.put("isTransmit", "life_cycle");
    dictNameFieldNameMap.put("isEncrypt", "rtu_is_encrypt");
    if (feederAreaDesc.intValue() == 1) {
      this.logger.info("==========> wuxi: feederAreaDesc==1");
      dictNameFieldNameMap.put("organization", "menu_rtu_organization");
    } 
    Map<String, ColumnRefInfo> filedRefInfoMap = new HashMap<>();
    if (replaceOrgIdWithAreaResp.intValue() == 1) {
      filedRefInfoMap.put("areaResp", new ColumnRefInfo("auth_region", "id", "description", ""));
      filedRefInfoMap.put("divisionId", new ColumnRefInfo("auth_region", "id", "description", ""));
    } else if (feederAreaDesc.intValue() != 1) {
      filedRefInfoMap.put("divisionId", new ColumnRefInfo("con_division", "id", "description", ""));
    } 
    filedRefInfoMap.put("stationId", new ColumnRefInfo("con_station", "id", "description", ""));
    filedRefInfoMap.put("feederId", new ColumnRefInfo("con_feeder", "id", "description", ""));
    try {
      CommonTranslateUtil.translateMultiDictColumn(records, dictNameFieldNameMap, TranslateUtil.DictItemColumRefType.VALUE_COLUMN);
      CommonTranslateUtil.translateMultiReferenceColumn(records, null, TranslateUtil.DictItemColumRefType.ID_COLUMN, filedRefInfoMap);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    if (feederAreaDesc.intValue() == 1) {
      this.logger.info("==========> wuxi: feederAreaDesc==1");
      for (int k = 0; k < records.size(); k++)
        ((Map)records.get(k)).put("divisionIdTranslateValue", ((Map)records.get(k)).get("organizationTranslateValue")); 
    } 
    return pb;
  }
  
  public PagingBean queryRecordsDetial(QueryFilter queryFilter) {
    String printFullSql = "select obj_id, occur_time, content from scada_event ";
    queryFilter.addNumberFieldEqualCondition("alarm_type", Integer.valueOf(6));
    queryFilter.addNumberFieldEqualCondition("dev_id", Integer.valueOf(2));
    queryFilter.addStringFieldLikeCondition("key_id_tag", "%fes_rtu%status%");
    String hh = queryFilter.getFullFilledValueSql();
    if (hh != null && !hh.isEmpty() && hh.trim().length() > 0)
      printFullSql = printFullSql + " where " + hh; 
    this.logger.info(printFullSql);
    PagingBean pb = this.jdbcDao.queryForPaging(printFullSql, null, queryFilter.getPageSize().intValue(), queryFilter.getPageIndex().intValue());
    Map<String, ColumnRefInfo> filedRefInfoMap = new HashMap<>();
    filedRefInfoMap.put("objId", new ColumnRefInfo("fes_rtu", "id", "description", ""));
    try {
      CommonTranslateUtil.translateMultiReferenceColumn(pb.getData(), null, TranslateUtil.DictItemColumRefType.ID_COLUMN, filedRefInfoMap);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return pb;
  }
}
